diff -urN ../VisualBoyAdvance-1.7.2/src/arm-new.h ./src/arm-new.h
--- ../VisualBoyAdvance-1.7.2/src/arm-new.h	2004-05-13 22:57:11 +0900
+++ ./src/arm-new.h	2006-08-25 22:30:08 +0900
@@ -5511,10 +6901,10 @@
     CPUWriteMemory(address, reg[(num)].I);\
     if(!offset) {\
       reg[base].I = temp;\
-      clockTicks += 1 + CPUUpdateTicksAccess32(address);\
+      clockTicks += 1 + dataTicksAccess32(address);\
       offset = 1;\
     } else {\
-      clockTicks += 1 + CPUUpdateTicksAccessSeq32(address);\
+      clockTicks += 1 + dataTicksAccessSeq32(address);\
     }\
     address += 4;\
   }
@@ -5522,22 +6912,23 @@
   if(opcode & (val)) {\
     CPUWriteMemory(address, reg[(num)].I);\
     if(!offset) {\
-      clockTicks += 1 + CPUUpdateTicksAccess32(address);\
+      clockTicks += 1 + dataTicksAccess32(address);\
       offset = 1;\
     } else {\
-      clockTicks += 1 + CPUUpdateTicksAccessSeq32(address);\
+      clockTicks += 1 + dataTicksAccessSeq32(address);\
     }\
     address += 4;\
   }
     
   CASE_16(0x800)
-    // STMDA Rn, {Rlist}
     {
+      // STMDA Rn, {Rlist}
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int base = (opcode & 0x000F0000) >> 16;
       u32 temp = reg[base].I - 
         4 * (cpuBitsSet[opcode & 255] + cpuBitsSet[(opcode >> 8) & 255]);
       u32 address = (temp + 4) & 0xFFFFFFFC;
-      clockTicks += 2;
       int offset = 0;
       STM_REG(1, 0);
       STM_REG(2, 1);
@@ -5557,20 +6948,22 @@
       if(opcode & 32768) {
         CPUWriteMemory(address, reg[15].I+4);
         if(!offset)
-          clockTicks += 1 + CPUUpdateTicksAccess32(address);
+          clockTicks += 1 + dataTicksAccess32(address);
         else
-          clockTicks += 1 + CPUUpdateTicksAccessSeq32(address);
+          clockTicks += 1 + dataTicksAccessSeq32(address);
       }
+      clockTicks += 1 + codeTicksAccess32(armNextPC);
     }
     break;
   CASE_16(0x820)
     {
       // STMDA Rn!, {Rlist}
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int base = (opcode & 0x000F0000) >> 16;
       u32 temp = reg[base].I - 
         4 * (cpuBitsSet[opcode & 255] + cpuBitsSet[(opcode >> 8) & 255]);
       u32 address = (temp+4) & 0xFFFFFFFC;
-      clockTicks += 2;
       int offset = 0;
 
       STMW_REG(1, 0);
@@ -5591,21 +6984,23 @@
       if(opcode & 32768) {
         CPUWriteMemory(address, reg[15].I+4);
         if(!offset)
-          clockTicks += 1 + CPUUpdateTicksAccess32(address);
+          clockTicks += 1 + dataTicksAccess32(address);
         else
-          clockTicks += 1 + CPUUpdateTicksAccessSeq32(address);
+          clockTicks += 1 + dataTicksAccessSeq32(address);
         reg[base].I = temp;
       }
+      clockTicks += 1 + codeTicksAccess32(armNextPC);
     }
   break;
   CASE_16(0x840)
     {
       // STMDA Rn, {Rlist}^
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int base = (opcode & 0x000F0000) >> 16;
       u32 temp = reg[base].I - 
         4 * (cpuBitsSet[opcode & 255] + cpuBitsSet[(opcode >> 8) & 255]);
       u32 address = (temp+4) & 0xFFFFFFFC;
-      clockTicks += 2;
       int offset = 0;
 
       STM_REG(1, 0);
@@ -5642,20 +7037,22 @@
       if(opcode & 32768) {
         CPUWriteMemory(address, reg[15].I+4);
         if(!offset)
-          clockTicks += 1 + CPUUpdateTicksAccess32(address);
+          clockTicks += 1 + dataTicksAccess32(address);
         else
-          clockTicks += 1 + CPUUpdateTicksAccessSeq32(address);
+          clockTicks += 1 + dataTicksAccessSeq32(address);
       }
+      clockTicks += 1 + codeTicksAccess32(armNextPC);
     }
     break;
   CASE_16(0x860)
     {
       // STMDA Rn!, {Rlist}^
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int base = (opcode & 0x000F0000) >> 16;
       u32 temp = reg[base].I - 
         4 * (cpuBitsSet[opcode & 255] + cpuBitsSet[(opcode >> 8) & 255]);
       u32 address = (temp+4) & 0xFFFFFFFC;
-      clockTicks += 2;
       int offset = 0;
 
       STMW_REG(1, 0);
@@ -5692,20 +7089,22 @@
       if(opcode & 32768) {
         CPUWriteMemory(address, reg[15].I+4);
         if(!offset)
-          clockTicks += 1 + CPUUpdateTicksAccess32(address);
+          clockTicks += 1 + dataTicksAccess32(address);
         else
-          clockTicks += 1 + CPUUpdateTicksAccessSeq32(address);
+          clockTicks += 1 + dataTicksAccessSeq32(address);
         reg[base].I = temp;
       }
+      clockTicks += 1 + codeTicksAccess32(armNextPC);
     }
     break;
   
   CASE_16(0x880)
     {
       // STMIA Rn, {Rlist}
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int base = (opcode & 0x000F0000) >> 16;
       u32 address = reg[base].I & 0xFFFFFFFC;
-      clockTicks += 2;
       int offset = 0;
       STM_REG(1, 0);
       STM_REG(2, 1);
@@ -5725,18 +7124,20 @@
       if(opcode & 32768) {
         CPUWriteMemory(address, reg[15].I+4);
         if(!offset)
-          clockTicks += 1 + CPUUpdateTicksAccess32(address);
+          clockTicks += 1 + dataTicksAccess32(address);
         else
-          clockTicks += 1 + CPUUpdateTicksAccessSeq32(address);
+          clockTicks += 1 + dataTicksAccessSeq32(address);
       }
+      clockTicks += 1 + codeTicksAccess32(armNextPC);
     }
   break;
   CASE_16(0x8a0)
     {
       // STMIA Rn!, {Rlist}
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int base = (opcode & 0x000F0000) >> 16;
       u32 address = reg[base].I & 0xFFFFFFFC;
-      clockTicks += 2;
       int offset = 0;
       u32 temp = reg[base].I + 4*(cpuBitsSet[opcode & 0xFF] +
                                   cpuBitsSet[(opcode >> 8) & 255]);
@@ -5759,18 +7160,20 @@
         CPUWriteMemory(address, reg[15].I+4);
         if(!offset) {
           reg[base].I = temp;
-          clockTicks += 1 + CPUUpdateTicksAccess32(address);
+          clockTicks += 1 + dataTicksAccess32(address);
         } else
-          clockTicks += 1 + CPUUpdateTicksAccessSeq32(address);
+          clockTicks += 1 + dataTicksAccessSeq32(address);
       }
+      clockTicks += 1 + codeTicksAccess32(armNextPC);
     }
   break;
   CASE_16(0x8c0)
     {
       // STMIA Rn, {Rlist}^
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int base = (opcode & 0x000F0000) >> 16;
       u32 address = reg[base].I & 0xFFFFFFFC;
-      clockTicks += 2;
       int offset = 0;
       STM_REG(1, 0);
       STM_REG(2, 1);
@@ -5803,18 +7206,20 @@
       if(opcode & 32768) {
         CPUWriteMemory(address, reg[15].I+4);
         if(!offset)
-          clockTicks += 1 + CPUUpdateTicksAccess32(address);
+          clockTicks += 1 + dataTicksAccess32(address);
         else
-          clockTicks += 1 + CPUUpdateTicksAccessSeq32(address);
+          clockTicks += 1 + dataTicksAccessSeq32(address);
       }
+      clockTicks += 1 + codeTicksAccess32(armNextPC);
     }
     break;
   CASE_16(0x8e0)
     {
       // STMIA Rn!, {Rlist}^
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int base = (opcode & 0x000F0000) >> 16;
       u32 address = reg[base].I & 0xFFFFFFFC;
-      clockTicks += 2;
       int offset = 0;
       u32 temp = reg[base].I + 4*(cpuBitsSet[opcode & 0xFF] +
                                   cpuBitsSet[(opcode >> 8) & 255]);    
@@ -5850,21 +7255,23 @@
         CPUWriteMemory(address, reg[15].I+4);
         if(!offset) {
           reg[base].I = temp;
-          clockTicks += 1 + CPUUpdateTicksAccess32(address);
+          clockTicks += 1 + dataTicksAccess32(address);
         } else
-          clockTicks += 1 + CPUUpdateTicksAccessSeq32(address);
+          clockTicks += 1 + dataTicksAccessSeq32(address);
       }
+      clockTicks += 1 + codeTicksAccess32(armNextPC);
     }
     break;
     
   CASE_16(0x900)
     {
       // STMDB Rn, {Rlist}
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int base = (opcode & 0x000F0000) >> 16;
       u32 temp = reg[base].I - 
         4 * (cpuBitsSet[opcode & 255] + cpuBitsSet[(opcode >> 8) & 255]);
       u32 address = temp & 0xFFFFFFFC;
-      clockTicks += 2;
       int offset = 0;
       STM_REG(1, 0);
       STM_REG(2, 1);
@@ -5884,20 +7291,22 @@
       if(opcode & 32768) {
         CPUWriteMemory(address, reg[15].I+4);
         if(!offset)
-          clockTicks += 1 + CPUUpdateTicksAccess32(address);
+          clockTicks += 1 + dataTicksAccess32(address);
         else
-          clockTicks += 1 + CPUUpdateTicksAccessSeq32(address);
+          clockTicks += 1 + dataTicksAccessSeq32(address);
       }
+      clockTicks += 1 + codeTicksAccess32(armNextPC);
     }
     break;
   CASE_16(0x920)
     {
       // STMDB Rn!, {Rlist}
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int base = (opcode & 0x000F0000) >> 16;
       u32 temp = reg[base].I - 
         4 * (cpuBitsSet[opcode & 255] + cpuBitsSet[(opcode >> 8) & 255]);
       u32 address = temp & 0xFFFFFFFC;
-      clockTicks += 2;
       int offset = 0;
 
       STMW_REG(1, 0);
@@ -5918,21 +7327,23 @@
       if(opcode & 32768) {
         CPUWriteMemory(address, reg[15].I+4);
         if(!offset)
-          clockTicks += 1 + CPUUpdateTicksAccess32(address);
+          clockTicks += 1 + dataTicksAccess32(address);
         else
-          clockTicks += 1 + CPUUpdateTicksAccessSeq32(address);
+          clockTicks += 1 + dataTicksAccessSeq32(address);
         reg[base].I = temp;
       }
+      clockTicks += 1 + codeTicksAccess32(armNextPC);
     }
   break;
   CASE_16(0x940)
     {
       // STMDB Rn, {Rlist}^
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int base = (opcode & 0x000F0000) >> 16;
       u32 temp = reg[base].I - 
         4 * (cpuBitsSet[opcode & 255] + cpuBitsSet[(opcode >> 8) & 255]);
       u32 address = temp & 0xFFFFFFFC;
-      clockTicks += 2;
       int offset = 0;
 
       STM_REG(1, 0);
@@ -5969,20 +7380,22 @@
       if(opcode & 32768) {
         CPUWriteMemory(address, reg[15].I+4);
         if(!offset)
-          clockTicks += 1 + CPUUpdateTicksAccess32(address);
+          clockTicks += 1 + dataTicksAccess32(address);
         else
-          clockTicks += 1 + CPUUpdateTicksAccessSeq32(address);
+          clockTicks += 1 + dataTicksAccessSeq32(address);
       }
+      clockTicks += 1 + codeTicksAccess32(armNextPC);
     }
     break;
   CASE_16(0x960)
     {
       // STMDB Rn!, {Rlist}^
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int base = (opcode & 0x000F0000) >> 16;
       u32 temp = reg[base].I - 
         4 * (cpuBitsSet[opcode & 255] + cpuBitsSet[(opcode >> 8) & 255]);
       u32 address = temp & 0xFFFFFFFC;
-      clockTicks += 2;
       int offset = 0;
 
       STMW_REG(1, 0);
@@ -6019,20 +7432,22 @@
       if(opcode & 32768) {
         CPUWriteMemory(address, reg[15].I+4);
         if(!offset)
-          clockTicks += 1 + CPUUpdateTicksAccess32(address);
+          clockTicks += 1 + dataTicksAccess32(address);
         else
-          clockTicks += 1 + CPUUpdateTicksAccessSeq32(address);
+          clockTicks += 1 + dataTicksAccessSeq32(address);
         reg[base].I = temp;
       }
+      clockTicks += 1 + codeTicksAccess32(armNextPC);
     }
     break;
 
   CASE_16(0x980)
-    // STMIB Rn, {Rlist}
     {
+      // STMIB Rn, {Rlist}
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int base = (opcode & 0x000F0000) >> 16;
       u32 address = (reg[base].I+4) & 0xFFFFFFFC;
-      clockTicks += 2;
       int offset = 0;
       STM_REG(1, 0);
       STM_REG(2, 1);
@@ -6052,18 +7467,20 @@
       if(opcode & 32768) {
         CPUWriteMemory(address, reg[15].I+4);
         if(!offset)
-          clockTicks += 1 + CPUUpdateTicksAccess32(address);
+          clockTicks += 1 + dataTicksAccess32(address);
         else
-          clockTicks += 1 + CPUUpdateTicksAccessSeq32(address);
+          clockTicks += 1 + dataTicksAccessSeq32(address);
       }
+      clockTicks += 1 + codeTicksAccess32(armNextPC);
     }
     break;
   CASE_16(0x9a0)
     {
       // STMIB Rn!, {Rlist}
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int base = (opcode & 0x000F0000) >> 16;
       u32 address = (reg[base].I+4) & 0xFFFFFFFC;
-      clockTicks += 2;
       int offset = 0;
       u32 temp = reg[base].I + 4*(cpuBitsSet[opcode & 0xFF] +
                                   cpuBitsSet[(opcode >> 8) & 255]);
@@ -6086,18 +7503,20 @@
         CPUWriteMemory(address, reg[15].I+4);
         if(!offset) {
           reg[base].I = temp;
-          clockTicks += 1 + CPUUpdateTicksAccess32(address);
+          clockTicks += 1 + dataTicksAccess32(address);
         } else
-          clockTicks += 1 + CPUUpdateTicksAccessSeq32(address);
+          clockTicks += 1 + dataTicksAccessSeq32(address);
       }
+      clockTicks += 1 + codeTicksAccess32(armNextPC);
     }
     break;
   CASE_16(0x9c0)
     {
       // STMIB Rn, {Rlist}^
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int base = (opcode & 0x000F0000) >> 16;
       u32 address = (reg[base].I+4) & 0xFFFFFFFC;
-      clockTicks += 2;
       int offset = 0;
       STM_REG(1, 0);
       STM_REG(2, 1);
@@ -6130,18 +7549,20 @@
       if(opcode & 32768) {
         CPUWriteMemory(address, reg[15].I+4);
         if(!offset)
-          clockTicks += 1 + CPUUpdateTicksAccess32(address);
+          clockTicks += 1 + dataTicksAccess32(address);
         else
-          clockTicks += 1 + CPUUpdateTicksAccessSeq32(address);
+          clockTicks += 1 + dataTicksAccessSeq32(address);
       }
+      clockTicks += 1 + codeTicksAccess32(armNextPC);
     }
     break;
   CASE_16(0x9e0)
     {
       // STMIB Rn!, {Rlist}^
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int base = (opcode & 0x000F0000) >> 16;
       u32 address = (reg[base].I+4) & 0xFFFFFFFC;
-      clockTicks += 2;
       int offset = 0;
       u32 temp = reg[base].I + 4*(cpuBitsSet[opcode & 0xFF] +
                                   cpuBitsSet[(opcode >> 8) & 255]);    
@@ -6177,10 +7598,11 @@
         CPUWriteMemory(address, reg[15].I+4);
         if(!offset) {
           reg[base].I = temp;
-          clockTicks += 1 + CPUUpdateTicksAccess32(address);
+          clockTicks += 1 + dataTicksAccess32(address);
         } else
-          clockTicks += 1 + CPUUpdateTicksAccessSeq32(address);
+          clockTicks += 1 + dataTicksAccessSeq32(address);
       }
+      clockTicks += 1 + codeTicksAccess32(armNextPC);
     }
     break;
     
@@ -6188,9 +7610,9 @@
   if(opcode & (val)) {\
     reg[(num)].I = CPUReadMemory(address);\
     if(offset)\
-      clockTicks += 1 + CPUUpdateTicksAccessSeq32(address);\
+      clockTicks += 1 + dataTicksAccessSeq32(address);\
     else {\
-      clockTicks += 1 + CPUUpdateTicksAccess32(address);\
+      clockTicks += 1 + dataTicksAccess32(address);\
       offset = 1;\
     }\
     address += 4;\
@@ -6199,11 +7621,13 @@
   CASE_16(0x810)
     {
       // LDMDA Rn, {Rlist}
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int base = (opcode & 0x000F0000) >> 16;
       u32 temp = reg[base].I - 
         4 * (cpuBitsSet[opcode & 255] + cpuBitsSet[(opcode >> 8) & 255]);
       u32 address = (temp + 4) & 0xFFFFFFFC;
-      clockTicks += 2;
+      clockTicks = 0;
       int offset = 0;
       LDM_REG(1, 0);
       LDM_REG(2, 1);
@@ -6222,23 +7646,28 @@
       LDM_REG(16384, 14);
       if(opcode & 32768) {
         reg[15].I = CPUReadMemory(address);
-        if (!offset)
-          clockTicks += 2 + CPUUpdateTicksAccess32(address);
-        else
-          clockTicks += 2 + CPUUpdateTicksAccessSeq32(address);
         armNextPC = reg[15].I;
         reg[15].I += 4;
+        ARM_PREFETCH;
+        if (!offset)
+          clockTicks += 1 + dataTicksAccess32(address);
+        else
+          clockTicks += 1 + dataTicksAccessSeq32(address);
+        clockTicks += 1 + codeTicksAccessSeq32(armNextPC);
       }
+      clockTicks += 2 + codeTicksAccess32(armNextPC);
     }
     break;
   CASE_16(0x830)
     {
       // LDMDA Rn!, {Rlist}
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int base = (opcode & 0x000F0000) >> 16;
       u32 temp = reg[base].I - 
         4 * (cpuBitsSet[opcode & 255] + cpuBitsSet[(opcode >> 8) & 255]);
       u32 address = (temp + 4) & 0xFFFFFFFC;
-      clockTicks += 2;
+      clockTicks = 0;
       int offset = 0;
       LDM_REG(1, 0);
       LDM_REG(2, 1);
@@ -6257,13 +7686,17 @@
       LDM_REG(16384, 14);
       if(opcode & 32768) {
         reg[15].I = CPUReadMemory(address);
-        if (!offset)
-          clockTicks += 2 + CPUUpdateTicksAccess32(address);
-        else
-          clockTicks += 2 + CPUUpdateTicksAccessSeq32(address);
+
         armNextPC = reg[15].I;
         reg[15].I += 4;
+        ARM_PREFETCH;
+        if (!offset)
+          clockTicks += 1 + dataTicksAccess32(address);
+        else
+          clockTicks += 1 + dataTicksAccessSeq32(address);
+        clockTicks += 1 + codeTicksAccessSeq32(armNextPC);
       }
+      clockTicks += 2 + codeTicksAccess32(armNextPC);
       if(!(opcode & (1 << base)))
         reg[base].I = temp;
     }
@@ -6271,11 +7704,13 @@
   CASE_16(0x850)
     {
       // LDMDA Rn, {Rlist}^
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int base = (opcode & 0x000F0000) >> 16;
       u32 temp = reg[base].I - 
         4 * (cpuBitsSet[opcode & 255] + cpuBitsSet[(opcode >> 8) & 255]);
       u32 address = (temp + 4) & 0xFFFFFFFC;
-      clockTicks += 2;
+      clockTicks = 0;
       int offset = 0;
       if(opcode & 0x8000) {
         LDM_REG(1, 0);
@@ -6295,18 +7730,16 @@
         LDM_REG(16384, 14);
 
         reg[15].I = CPUReadMemory(address);
-        if (!offset)
-          clockTicks += 2 + CPUUpdateTicksAccess32(address);
-        else
-          clockTicks += 2 + CPUUpdateTicksAccessSeq32(address);
 
         CPUSwitchMode(reg[17].I & 0x1f, false);
         if(armState) {
           armNextPC = reg[15].I & 0xFFFFFFFC;
           reg[15].I = armNextPC + 4;
+          ARM_PREFETCH;
         } else {
           armNextPC = reg[15].I & 0xFFFFFFFE;
           reg[15].I = armNextPC + 2;
+          THUMB_PREFETCH;
         }
       } else {
         LDM_REG(1, 0);
@@ -6339,17 +7772,25 @@
           LDM_REG(8192, 13);
           LDM_REG(16384, 14);
         }
+        if (!offset)
+          clockTicks += 1 + dataTicksAccess32(address);
+        else
+          clockTicks += 1 + dataTicksAccessSeq32(address);
+        clockTicks += 1 + codeTicksAccessSeq32(armNextPC);
       }
+        clockTicks += 2 + codeTicksAccess32(armNextPC);
     }
     break;
   CASE_16(0x870)
     {
       // LDMDA Rn!, {Rlist}^
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int base = (opcode & 0x000F0000) >> 16;
       u32 temp = reg[base].I - 
         4 * (cpuBitsSet[opcode & 255] + cpuBitsSet[(opcode >> 8) & 255]);
       u32 address = (temp + 4) & 0xFFFFFFFC;
-      clockTicks += 2;
+      clockTicks = 0;
       int offset = 0;
       if(opcode & 0x8000) {
         LDM_REG(1, 0);
@@ -6369,10 +7810,6 @@
         LDM_REG(16384, 14);
 
         reg[15].I = CPUReadMemory(address);
-        if(!offset)
-          clockTicks += 2 + CPUUpdateTicksAccess32(address);      
-        else
-          clockTicks += 2 + CPUUpdateTicksAccessSeq32(address);
 
         if(!(opcode & (1 << base)))    
           reg[base].I = temp;
@@ -6381,9 +7818,11 @@
         if(armState) {
           armNextPC = reg[15].I & 0xFFFFFFFC;
           reg[15].I = armNextPC + 4;
+          ARM_PREFETCH;
         } else {
           armNextPC = reg[15].I & 0xFFFFFFFE;
           reg[15].I = armNextPC + 2;
+          THUMB_PREFETCH;
         }
       } else {
         LDM_REG(1, 0);
@@ -6419,16 +7858,24 @@
 
         if(!(opcode & (1 << base)))    
           reg[base].I = temp;
+        if (!offset)
+          clockTicks += 1 + dataTicksAccess32(address);
+        else
+          clockTicks += 1 + dataTicksAccessSeq32(address);
+        clockTicks += 1 + codeTicksAccessSeq32(armNextPC);
       }
+      clockTicks += 2 + codeTicksAccess32(armNextPC);
     }
     break;
     
   CASE_16(0x890)
     {
       // LDMIA Rn, {Rlist}
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int base = (opcode & 0x000F0000) >> 16;
       u32 address = reg[base].I & 0xFFFFFFFC;
-      clockTicks += 2;
+      clockTicks = 0;
       int offset = 0;
       LDM_REG(1, 0);
       LDM_REG(2, 1);
@@ -6447,23 +7894,29 @@
       LDM_REG(16384, 14);
       if(opcode & 32768) {
         reg[15].I = CPUReadMemory(address);
-        if (!offset)
-          clockTicks += 2 + CPUUpdateTicksAccess32(address);
-        else
-          clockTicks += 2 + CPUUpdateTicksAccessSeq32(address);
+
         armNextPC = reg[15].I;
         reg[15].I += 4;
+        ARM_PREFETCH;
+        if (!offset)
+          clockTicks += 1 + dataTicksAccess32(address);
+        else
+          clockTicks += 1 + dataTicksAccessSeq32(address);
+        clockTicks += 1 + codeTicksAccessSeq32(armNextPC);
       }
+      clockTicks += 2 + codeTicksAccess32(armNextPC);
     }
   break;
   CASE_16(0x8b0)
     {
       // LDMIA Rn!, {Rlist}
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int base = (opcode & 0x000F0000) >> 16;
       u32 temp = reg[base].I + 
         4 * (cpuBitsSet[opcode & 255] + cpuBitsSet[(opcode >> 8) & 255]);
       u32 address = reg[base].I & 0xFFFFFFFC;
-      clockTicks += 2;
+      clockTicks = 0;
       int offset = 0;
       LDM_REG(1, 0);
       LDM_REG(2, 1);
@@ -6482,13 +7935,17 @@
       LDM_REG(16384, 14);
       if(opcode & 32768) {
         reg[15].I = CPUReadMemory(address);
-        if (!offset)
-          clockTicks += 2 + CPUUpdateTicksAccess32(address);
-        else
-          clockTicks += 2 + CPUUpdateTicksAccessSeq32(address);
+
         armNextPC = reg[15].I;
         reg[15].I += 4;
+        ARM_PREFETCH;
+        if (!offset)
+          clockTicks += 1 + dataTicksAccess32(address);
+        else
+          clockTicks += 1 + dataTicksAccessSeq32(address);
+        clockTicks += 1 + codeTicksAccessSeq32(armNextPC);
       }
+      clockTicks += 2 + codeTicksAccess32(armNextPC);
       if(!(opcode & (1 << base)))
         reg[base].I = temp;
     }
@@ -6496,9 +7953,11 @@
   CASE_16(0x8d0)
     {
       // LDMIA Rn, {Rlist}^
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int base = (opcode & 0x000F0000) >> 16;
       u32 address = reg[base].I & 0xFFFFFFFC;
-      clockTicks += 2;
+      clockTicks = 0;
       int offset = 0;
       if(opcode & 0x8000) {
         LDM_REG(1, 0);
@@ -6518,18 +7977,16 @@
         LDM_REG(16384, 14);
 
         reg[15].I = CPUReadMemory(address);
-        if (!offset)
-          clockTicks += 2 + CPUUpdateTicksAccess32(address);
-        else
-          clockTicks += 2 + CPUUpdateTicksAccessSeq32(address);
 
         CPUSwitchMode(reg[17].I & 0x1f, false);
         if(armState) {
           armNextPC = reg[15].I & 0xFFFFFFFC;
           reg[15].I = armNextPC + 4;
+          ARM_PREFETCH;
         } else {
           armNextPC = reg[15].I & 0xFFFFFFFE;
           reg[15].I = armNextPC + 2;
+          THUMB_PREFETCH;
         }
       } else {
         LDM_REG(1, 0);
@@ -6562,17 +8019,25 @@
           LDM_REG(8192, 13);
           LDM_REG(16384, 14);
         }
+        if (!offset)
+          clockTicks += 1 + dataTicksAccess32(address);
+        else
+          clockTicks += 1 + dataTicksAccessSeq32(address);
+        clockTicks += 1 + codeTicksAccessSeq32(armNextPC);
       }
+      clockTicks += 2 + codeTicksAccess32(armNextPC);
     }
   break;
   CASE_16(0x8f0)
     {
       // LDMIA Rn!, {Rlist}^
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int base = (opcode & 0x000F0000) >> 16;
       u32 temp = reg[base].I +
         4 * (cpuBitsSet[opcode & 255] + cpuBitsSet[(opcode >> 8) & 255]);
       u32 address = reg[base].I & 0xFFFFFFFC;
-      clockTicks += 2;
+      clockTicks = 0;
       int offset = 0;
       if(opcode & 0x8000) {
         LDM_REG(1, 0);
@@ -6592,10 +8057,6 @@
         LDM_REG(16384, 14);
 
         reg[15].I = CPUReadMemory(address);
-        if(!offset)
-          clockTicks += 2 + CPUUpdateTicksAccess32(address);      
-        else
-          clockTicks += 2 + CPUUpdateTicksAccessSeq32(address);
 
         if(!(opcode & (1 << base)))    
           reg[base].I = temp;
@@ -6604,9 +8065,11 @@
         if(armState) {
           armNextPC = reg[15].I & 0xFFFFFFFC;
           reg[15].I = armNextPC + 4;
+          ARM_PREFETCH;
         } else {
           armNextPC = reg[15].I & 0xFFFFFFFE;
           reg[15].I = armNextPC + 2;
+          THUMB_PREFETCH;
         }
       } else {
         LDM_REG(1, 0);
@@ -6642,18 +8105,26 @@
 
         if(!(opcode & (1 << base)))    
           reg[base].I = temp;
+        if (!offset)
+          clockTicks += 1 + dataTicksAccess32(address);
+        else
+          clockTicks += 1 + dataTicksAccessSeq32(address);
+        clockTicks += 1 + codeTicksAccessSeq32(armNextPC);
       }
+      clockTicks += 2 + codeTicksAccess32(armNextPC);
     }
     break;
     
   CASE_16(0x910)
     {
       // LDMDB Rn, {Rlist}
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int base = (opcode & 0x000F0000) >> 16;
       u32 temp = reg[base].I - 
         4 * (cpuBitsSet[opcode & 255] + cpuBitsSet[(opcode >> 8) & 255]);
       u32 address = temp & 0xFFFFFFFC;
-      clockTicks += 2;
+      clockTicks = 0;
       int offset = 0;
       LDM_REG(1, 0);
       LDM_REG(2, 1);
@@ -6672,23 +8143,29 @@
       LDM_REG(16384, 14);
       if(opcode & 32768) {
         reg[15].I = CPUReadMemory(address);
-        if (!offset)
-          clockTicks += 2 + CPUUpdateTicksAccess32(address);
-        else
-          clockTicks += 2 + CPUUpdateTicksAccessSeq32(address);
+
         armNextPC = reg[15].I;
         reg[15].I += 4;
+        ARM_PREFETCH;
+        if (!offset)
+          clockTicks += 1 + dataTicksAccess32(address);
+        else
+          clockTicks += 1 + dataTicksAccessSeq32(address);
+        clockTicks += 1 + codeTicksAccessSeq32(armNextPC);
       }
+      clockTicks += 2 + codeTicksAccess32(armNextPC);
     }
     break;
   CASE_16(0x930)
     {
       // LDMDB Rn!, {Rlist}
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int base = (opcode & 0x000F0000) >> 16;
       u32 temp = reg[base].I - 
         4 * (cpuBitsSet[opcode & 255] + cpuBitsSet[(opcode >> 8) & 255]);
       u32 address = temp & 0xFFFFFFFC;
-      clockTicks += 2;
+      clockTicks = 0;
       int offset = 0;
       LDM_REG(1, 0);
       LDM_REG(2, 1);
@@ -6707,13 +8184,17 @@
       LDM_REG(16384, 14);
       if(opcode & 32768) {
         reg[15].I = CPUReadMemory(address);
-        if (!offset)
-          clockTicks += 2 + CPUUpdateTicksAccess32(address);
-        else
-          clockTicks += 2 + CPUUpdateTicksAccessSeq32(address);
+
         armNextPC = reg[15].I;
         reg[15].I += 4;
+        ARM_PREFETCH;
+        if (!offset)
+          clockTicks += 1 + dataTicksAccess32(address);
+        else
+          clockTicks += 1 + dataTicksAccessSeq32(address);
+        clockTicks += 1 + codeTicksAccessSeq32(armNextPC);
       }
+      clockTicks += 2 + codeTicksAccess32(armNextPC);
       if(!(opcode & (1 << base)))
         reg[base].I = temp;
     }
@@ -6721,11 +8202,13 @@
   CASE_16(0x950)
     {
       // LDMDB Rn, {Rlist}^
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int base = (opcode & 0x000F0000) >> 16;
       u32 temp = reg[base].I - 
         4 * (cpuBitsSet[opcode & 255] + cpuBitsSet[(opcode >> 8) & 255]);
       u32 address = temp & 0xFFFFFFFC;
-      clockTicks += 2;
+      clockTicks = 0;
       int offset = 0;
       if(opcode & 0x8000) {
         LDM_REG(1, 0);
@@ -6745,18 +8228,16 @@
         LDM_REG(16384, 14);
 
         reg[15].I = CPUReadMemory(address);
-        if (!offset)
-          clockTicks += 2 + CPUUpdateTicksAccess32(address);
-        else
-          clockTicks += 2 + CPUUpdateTicksAccessSeq32(address);
 
         CPUSwitchMode(reg[17].I & 0x1f, false);
         if(armState) {
           armNextPC = reg[15].I & 0xFFFFFFFC;
           reg[15].I = armNextPC + 4;
+          ARM_PREFETCH;
         } else {
           armNextPC = reg[15].I & 0xFFFFFFFE;
           reg[15].I = armNextPC + 2;
+          THUMB_PREFETCH;
         }
       } else {
         LDM_REG(1, 0);
@@ -6789,17 +8270,25 @@
           LDM_REG(8192, 13);
           LDM_REG(16384, 14);
         }
+        if (!offset)
+          clockTicks += 1 + dataTicksAccess32(address);
+        else
+          clockTicks += 1 + dataTicksAccessSeq32(address);
+        clockTicks += 1 + codeTicksAccessSeq32(armNextPC);
       }
+      clockTicks += 2 + codeTicksAccess32(armNextPC);
     }
     break;
   CASE_16(0x970)
     {
       // LDMDB Rn!, {Rlist}^
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int base = (opcode & 0x000F0000) >> 16;
       u32 temp = reg[base].I - 
         4 * (cpuBitsSet[opcode & 255] + cpuBitsSet[(opcode >> 8) & 255]);
       u32 address = temp & 0xFFFFFFFC;
-      clockTicks += 2;
+      clockTicks = 0;
       int offset = 0;
       if(opcode & 0x8000) {
         LDM_REG(1, 0);
@@ -6819,10 +8308,6 @@
         LDM_REG(16384, 14);
 
         reg[15].I = CPUReadMemory(address);
-        if(!offset)
-          clockTicks += 2 + CPUUpdateTicksAccess32(address);      
-        else
-          clockTicks += 2 + CPUUpdateTicksAccessSeq32(address);
 
         if(!(opcode & (1 << base)))    
           reg[base].I = temp;
@@ -6831,9 +8316,11 @@
         if(armState) {
           armNextPC = reg[15].I & 0xFFFFFFFC;
           reg[15].I = armNextPC + 4;
+          ARM_PREFETCH;
         } else {
           armNextPC = reg[15].I & 0xFFFFFFFE;
           reg[15].I = armNextPC + 2;
+          THUMB_PREFETCH;
         }
       } else {
         LDM_REG(1, 0);
@@ -6869,16 +8356,24 @@
 
         if(!(opcode & (1 << base)))    
           reg[base].I = temp;
+        if (!offset)
+          clockTicks += 1 + dataTicksAccess32(address);
+        else
+          clockTicks += 1 + dataTicksAccessSeq32(address);
+        clockTicks += 1 + codeTicksAccessSeq32(armNextPC);
       }
+      clockTicks += 2 + codeTicksAccess32(armNextPC);
     }
     break;
     
   CASE_16(0x990)
     {
       // LDMIB Rn, {Rlist}
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int base = (opcode & 0x000F0000) >> 16;
       u32 address = (reg[base].I+4) & 0xFFFFFFFC;
-      clockTicks += 2;
+      clockTicks = 0;
       int offset = 0;
       LDM_REG(1, 0);
       LDM_REG(2, 1);
